alter table `ombutel`.`ombu_dahdi_analog_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_analog_profiles_ibfk_1`,
	add primary key (`profile_id`);

alter table `ombutel`.`ombu_dahdi_digital_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_digital_profiles_ibfk_1`,
	add primary key (`profile_id`);

alter table `ombutel`.`ombu_dahdi_fxo_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_fxo_profiles_ibfk_1`,
	add primary key (`profile_id`);

alter table `ombutel`.`ombu_dahdi_fxs_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_fxs_profiles_ibfk_1`,
	add primary key (`profile_id`);

alter table `ombutel`.`ombu_dahdi_r2_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_r2_profiles_ibfk_1`,
	add primary key (`profile_id`);

alter table `ombutel`.`ombu_dahdi_channels`
	drop foreign key `ombu_dahdi_channels_ibfk_2`;

alter table `ombutel`.`ombu_dahdi_profiles`
	drop index `profile_id`,
	drop foreign key `ombu_dahdi_profiles_ibfk_1`,
	modify column `profile_id` int unsigned not null,
	add primary key (`profile_id`);

-- Needs to be done separately due to MariaDB bug (errno: 121 "Duplicate key on write or update")
alter table `ombutel`.`ombu_dahdi_profiles`
	add constraint foreign key `ombu_dahdi_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_device_profiles` (`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_analog_profiles`
	add constraint foreign key `ombu_dahdi_analog_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_dahdi_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_digital_profiles`
	add constraint foreign key `ombu_dahdi_digital_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_dahdi_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_fxo_profiles`
	add constraint foreign key `ombu_dahdi_fxo_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_dahdi_analog_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_fxs_profiles`
	add constraint foreign key `ombu_dahdi_fxs_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_dahdi_analog_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_r2_profiles`
	add constraint foreign key `ombu_dahdi_r2_profiles_ibfk_1` (`profile_id`) references `ombutel`.`ombu_dahdi_digital_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_dahdi_channels`
	add constraint foreign key `ombu_dahdi_channels_ibfk_2` (`profile_id`) references `ombutel`.`ombu_dahdi_profiles`(`profile_id`) on delete cascade;

alter table `ombutel`.`ombu_sip_devices`
	add primary key (`device_id`),
	drop index `device_id`;

alter table `ombutel`.`ombu_iax_devices`
	add primary key (`device_id`),
	drop index `device_id`;

alter table `ombutel`.`ombu_fxs_devices`
	add primary key (`device_id`),
	drop index `device_id`;

alter table `ombutel`.`ombu_sip_profiles`
	add primary key (`profile_id`),
	drop index `profile_id`;

alter table `ombutel`.`ombu_iax_profiles`
	add primary key (`profile_id`),
	drop index `profile_id`;

alter table `ombutel`.`dpma_voicemail_applications`
	add primary key (`dpma_application_id`),
	drop index `dpma_application_id`;

alter table `ombutel`.`dpma_status_applications`
	add primary key (`dpma_application_id`),
	drop index `dpma_application_id`;

alter table `ombutel`.`dpma_queue_applications`
	add primary key (`dpma_application_id`),
	drop index `dpma_application_id`;

alter table `ombutel`.`dpma_parking_applications`
	add primary key (`dpma_application_id`),
	drop index `dpma_application_id`;

alter table `ombutel`.`dpma_custom_applications`
	add primary key (`dpma_application_id`),
	drop index `dpma_application_id`;
