create table `ombutel`.`ombu_applications` (
	`application_id` int unsigned not null auto_increment,
	`name` varchar(255) not null,
	`key` binary(64) not null,
	primary key (`application_id`),
	unique index (`name`),
	unique index (`key`)
);

create table `ombutel`.`ombu_application_users` (
	`application_id` int unsigned not null,
	`user_id` int unsigned not null,
	foreign key (`application_id`) references `ombutel`.`ombu_applications`(`application_id`) on delete cascade,
	foreign key (`user_id`) references `ombutel`.`ombu_users`(`user_id`) on delete cascade
);

insert into `ombutel`.`ombu_modules` (`name`, `has_dialplan`, `admin`, `version`, `portal`) values ("app_access", "no", "yes", "1.0", "no");
select last_insert_id() into @module_id;

insert into `ombutel`.`ombu_menu` (`label`, `parent_id`, `module_id`, `sort`)
select
	"menu.app_access",
	`parent`.`menu_id`
	,@module_id,
	4
from `ombutel`.`ombu_menu` as `parent`
left join `ombutel`.`ombu_menu` as `grandparent` on (`grandparent`.`menu_id` = `parent`.`parent_id`)
where `parent`.`label` = "menu.admin" and `grandparent`.`label` = "menu.admin";

insert into `ombutel`.`ombu_role_privileges` (`role_id`, `module_id`, `allow_view`, `allow_add`, `allow_edit`, `allow_delete`)
select `role_id`, @module_id, "yes", "yes", "yes", "yes" from `ombutel`.`ombu_roles` where `superadmin` = "yes";
